--VERSION 0.0.17
--DATE 21 09 2014

local RLRFrame=CreateFrame("Frame") -- creating  a frame for determining what the content of the loot roll frame is (probably unnecessary?)
RLRFrame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
RLRFrame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
RLRFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED"); -- Fired when about to log out
RLRFrame:RegisterEvent("RAID_ROSTER_UPDATE"); --Fired when about to log out
RLRFrame:RegisterEvent("CHAT_MSG_ADDON"); -- 
RLRFrame:SetScript("OnEvent", RLRFrame.OnEvent); --probably sets script so that when an event fires, the function below is ran?

function RLRFrame:OnEvent(event,arg1,arg2,arg3,arg4) -- function pertaining to the frame that checks addon being loaded (probably very wrong to do it like this)
 			
	if event == "ADDON_LOADED" and arg1 == "RankedLootRoll" then  --checking that the addon being loaded is this one
			--message ("RLR main lua file v 0.0.5 loaded properly") --for some reason, message shows here, while print does not
			RegisterAddonMessagePrefix("RLR")
			RegisterAddonMessagePrefix("RLRReply")
			RegisterAddonMessagePrefix("RLRItemLink")
			RegisterAddonMessagePrefix("RLRRollAnnounce")
			RegisterAddonMessagePrefix("RLRVersion")
			RegisterAddonMessagePrefix("RLRAwarded")
			RegisterAddonMessagePrefix("RLRSendRSync")
			RegisterAddonMessagePrefix("RLRSKItem")
			RegisterAddonMessagePrefix("RLRNuke")
			RegisterAddonMessagePrefix("RLREligibles")
						
			print("Registered 10 prefixes")
			
			if RLRItemSlotsTable==nil then RLRFunctions.Initialize() end
			--ItemRollFrame:Hide()
			--print (event)
			--	if RLRSavedData == nil then -- for some reason, when I use print, it doesn´t show, but if I use message, it does
			--			print ("Setting RLRDataToSave to 0 since it is registering as nil")
			--			RLRSavedData = 0; -- setting it to 0 so that I can check if it saved after running it for the first time.
			--	else	 
			--		 -- TO BE IMPLEMENTED - print last entry from RLRSavedData
			--	end --end of if block checking RLRSavedData
		
		--elseif event == "CHAT_MSG_ADDON" then --and arg2 ~= "RLRReply" then
		--	print("RLR report: event= ",event,",arg1= ",arg1,",arg2=",arg2,",arg3=",arg3,",arg4=",arg4) --DEBUG
	end
		
	if event == "PARTY_LOOT_METHOD_CHANGED" then
			--print ("RLR DEBUG 43 - event fired", event)
			RLRFunctions.CheckLootMethod()
			if RLRSession.VersionSaid~=true then RLRFunctions.VersionSay()
			end
	end	
	
	if event == "CHAT_MSG_ADDON" and arg1 == "RLRReply" then
		RLRFunctions.ReceiveReply(arg2)
		
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRItemLink" then
		--print("Debugging CHAT_MSG_ADDON event handler in RankedLootRoll.lua: arg2=",arg2)
	--	print("RLR message: Anyone calling dibs on :",arg2,"?") -- DEBUG ONLY
		RLRFunctions.ShowFrame(arg1,arg2)
	
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRRollAnnounce" then	 
		--print("RLRML DEBUG 35-received RLRRaidRollAnnounce, TODO is pass it to the history box")
		RLRFunctions.RollAnnounce(arg2)
	
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRAwarded" then	 
		RLRFunctions.PrintAwarded(arg2)

	
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRSKItem" then	 
		RLRFunctions.ShowFrame(arg1,arg2)
	
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRSendRSync" then	 
		RLRFunctions.ProcessGuildRankSync(arg2)
	
	
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRNuke" then
		RLRFunctions.Nuke()
	
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRVersion" then	 
		RLRFunctions.VersionListen(arg2)
	
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLREligibles" then	 
		RLRFunctions.SaveEligibles(arg2)
	
	end
	
end

--end of function RLRFrame


RLRFrame:SetScript("OnEvent", RLRFrame.OnEvent); -- this is not doing what I want it to do (which is to register the slash command) but if I take it away, the message at line 10 doesn´t fire
function SlashCmdList.rlr(msg, modifier)
print("registering slash command /rlr ");
SLASH_RLR = "/rlr";
message("registering slash command /rlr ");
end

-- TABLES GET DEFINED BELOW HERE
RLRFunctions = {} --  table for storing functions
RLRFunctionsSave=RLRFunctions
local RLRFunctions = RLRFunctions -- because of the tip that local functions are accessed faster (I still don´t understand how exactly this works though)
RLRData = {}
RLRSavedData ={} --table for stuff like options, versioning, etc 
RLRVersion="0017"
RLRChannels={}
RLRHistory={}
RLRHistoryIndex={}
RLRPlayerCounters={}
RLRSession={}
RLRGuildRanks={}

-- FUNCTIONS THAT DEAL WITH RLR COMM CHANNEL


function RLRFunctions.Strip(name) 
  return string.gsub(name, "%W", "")
end

function RLRFunctions.CheckSum (text)
	local counter = 1
	local len = string.len(text)
	for i=1,len do
		counter = counter + string.byte(text, i)*math.pow(31, len- i)
	end
	counter = math.fmod(counter, 7919)
	return string.format("%06x", counter)
end

function RLRFunctions.Initialize()
end

function RLRConcatRealmName(name,realm)
	--print("RLR DEBUG 109 RLRConcatRealmName realm =",realm)
	if realm~=nil then 
	name=strjoin ("-",name,realm)
	end
	return name
end

function RLRFunctions.CheckLootMethod() 
 -- TODO IN FUTURE - WHEN LOOT METHOD CHANGES, ASK WHETHER TO TURN ADDON ON. IF SO, SET SESSION VARIABLE WHICH OTHER EVENT CHECKS IN HANDLER WOULD CHECK BEFORE FIRING 
	local lootmethod=GetLootMethod()
			if not IsInGroup(Player) then --IF NOT IN GROUP, do nothing
			print ("not in group")
			end
			if lootmethod=="master" then --IF IN GROUP, JOIN THE RLR/RLRML COMM CHANNEL
			--print("RLR DEBUG 127 - Joining RLR/RLRML communication channel")
			RLRFunctions.Channel()
		end
end 

function RLRFunctions.Nuke()
StaticPopup_Show ("CONFIRM_NUKE")
-- wipe (RLRSavedData)
-- wipe (RLRHistory)
-- wipe (RLRPlayerCounters)
-- wipe (RLRChannels)
-- wipe (RLRItemSlotsTable)
-- wipe (RLRGuildRanks)
-- ReloadUI();
end

function RLRFunctions.SaveEligibles(message)
local LootItemGUID,eligibles=strsplit(";",message)
_G[LootItemGUID.."Table"].eligibles=eligibles
end


function RLRFunctions.NumberExactLength(text,length)
do
	--print ("RLR DEBUG 168 - text type=",type(text)," text=",text," length=",length)
		if type(text)~="number" then 
		
		return text
		end
		if type(text)=="number" then repeat
				if strlen(text)>length then 
					local text=string.sub(text,1,length)
				elseif strlen(text)<length then 
					local text=strjoin("","0",text)
				return text 
				end
				until strlen(text)==length
				--print (text)
				return text 
		end
	return text 
	end
return text 
end




function RLRFunctions.RealmDateTime()
local weekday, month, day, year = CalendarGetDate();
local hours,minutes = GetGameTime();
local day=RLRFunctions.NumberExactLength(day,2)
local month=RLRFunctions.NumberExactLength(month,2)
local hours=RLRFunctions.NumberExactLength(hours,2)
local minutes=RLRFunctions.NumberExactLength(minutes,2)
local realmDateTime=strjoin("",year, month, day, hours, minutes)
--print ("RLR DEBUG 149",realmDateTime)
return realmDateTime
end


function RLRFunctions.NameRollCount(name,rolltype)
--print ("RLR DEBUG 172: name,rolltype=",name,rolltype)
do
	if RLRPlayerCounters[name]==nil then tinsert(RLRPlayerCounters,name)
		RLRPlayerCounters[name]={}
		RLRPlayerCounters[name].Major=0
		RLRPlayerCounters[name].Minor=0
		RLRPlayerCounters[name].OffSpec=0
		RLRPlayerCounters[name].Pass=0
		RLRPlayerCounters[name].BidMS=0
		RLRPlayerCounters[name].BidOS=0
	end
	RLRPlayerCounters[name][rolltype]=(RLRPlayerCounters[name][rolltype])+1
	--print("RLR DEBUG 179 PlayerCounter for ",name,"/",rolltype," roll=", RLRPlayerCounters[""..name][""..rolltype])
end
end


function RLRFunctions.PrintAwarded(arg2)
do
local realmDateTime=RLRFunctions.RealmDateTime()
local LootItemGUID,luckywinner,item,itemLink,index,itemLevel,HighestCurrentItemLink,HighestCurrentItemLevel,rolltype,guildRankName,randomn=strsplit(";",arg2)
--print ("RLR DEBUG 226 -  LootItemGUID=",LootItemGUID,", luckywinner=",luckywinner,", item=",item,", itemLink=",itemLink,", index=",index,", itemLevel=",itemLevel,", rolltype=",rolltype,", HighestCurrentItemLink=",HighestCurrentItemLink,", HighestCurrentItemLevel=",HighestCurrentItemLevel,", guildRankName=",guildRankName,", randomn=",randomn)
local index=RLRFunctions.NumberExactLength(index,2)
tinsert(UISpecialFrames,LootItemGUID..";RollFrame")
if HighestCurrentItemLink==nil then local HighestCurrentItemLink,HighestCurrentItemLevel="?" end
	print ("RLR DEBUG 235:",luckywinner,"was awarded ",item)
	_G[LootItemGUID.."Table"].AwardedTo=luckywinner
	local index=strsub(index,1,1)
	RLRHistory[realmDateTime..index..randomn]={}
	if RLRHistory[realmDateTime..index..randomn] then 
						tinsert(RLRHistoryIndex,realmDateTime..index..randomn)
						tinsert(RLRHistory[realmDateTime..index..randomn],luckywinner)
						tinsert(RLRHistory[realmDateTime..index..randomn],rolltype)
						tinsert(RLRHistory[realmDateTime..index..randomn],item)
						tinsert(RLRHistory[realmDateTime..index..randomn],itemLink)
						tinsert(RLRHistory[realmDateTime..index..randomn],itemLevel)
						tinsert(RLRHistory[realmDateTime..index..randomn],HighestCurrentItemLink)
						tinsert(RLRHistory[realmDateTime..index..randomn],HighestCurrentItemLevel)
						tinsert(RLRHistory[realmDateTime..index..randomn],date())
						tinsert(RLRHistory[realmDateTime..index..randomn],guildRankName)
	
	_G[LootItemGUID..";RollFrame;Winner"]:Show()
	_G[LootItemGUID..";RollFrameItemName;AwardLoot"]:Hide()
	end
end
end

function RLRFunctions.RequestGuildRankSync(SourceOfSync)
do
	local method, partyMaster, raidMaster = GetLootMethod()
	if SourceOfSync==nil then 
		local SourceOfSync=RLRFunctions.GetMLName()
		SendAddonMessage("RLRRequestRSync","requesting guild rank sync","WHISPER",SourceOfSync)
		print (SourceOfSync)
	else
		SendAddonMessage("RLRRequestRSync","requesting guild rank sync","WHISPER",SourceOfSync)
	end
	wipe(RLRGuildRanks)
end
end

function RLRFunctions.ProcessGuildRankSync(message)
do
	local k,v,rollmin,rollmax=strsplit(";",message)
	print ("copying values for rank ",v)
	tinsert(RLRGuildRanks,v)
	RLRGuildRanks[v]={}
	tinsert(RLRGuildRanks[v],rollmin)
	tinsert(RLRGuildRanks[v],rollmax)
end
end

function RLRFunctions.CheckForTier(itemName)
local str1,str2,str3,str4,str5=strsplit(" ",itemName)
	local tiernames=("Vanquisher;Conqueror;Protector;Defender;Champion;Hero")
	if str5~=nil and string.find(tiernames,str5)~= nil then 
	-- --if str5=="Vanquisher" or str5=="Conqueror" or str5=="Protector" or str5=="Defender" or str5=="Champion"  or str5=="Hero" then
	local tierPiece=str1
	-- --print("RLRML DEBUG 554 - tier piece detected:", tierPiece)
	return tierPiece
	end
return TierPiece 
end


function RLRFunctions.TierSlotMatch(lootName)
do
	local lootName=RLRFunctions.CheckForTier(lootName)
	print ("RLR DEBUG 280 - lootName=",lootName)
	
-- essence, "essence of the forlorn(missing what)", "Vanquisher's Mark of Sanctification", 	"Protector's Mark of Sanctification", "Conqueror's Mark of Sanctification", 
	-- if lootName~="Helm" and lootName~="Shoulders" and lootName~= "Chest" and lootName~= "Gauntlets" and lootName~= "Leggings" and lootName~= "Pauldrons" and lootName~= "Mantle" and lootName~= "Gloves" and lootName~= "Chestguard"  and lootName~= "Spaulders" and lootName~= "Crown" and lootName~= "Regalia" and lootName~= "Belt" and lootName~= "Boots" and lootName~= "Bracers" then local lootName="unknown" return lootName end

	if  RLRTierSlotsTable==nil then
		RLRTierSlotsTable={}
		RLRTierSlotsTable["Helm"]="INVTYPE_HEAD"
		RLRTierSlotsTable["Crown"]="INVTYPE_HEAD"
		
		RLRTierSlotsTable["Shoulders"]="INVTYPE_SHOULDER"
		RLRTierSlotsTable["Spaulders"]="INVTYPE_SHOULDER"
		RLRTierSlotsTable["Pauldrons"]="INVTYPE_SHOULDER"
		RLRTierSlotsTable["Mantle"]="INVTYPE_SHOULDER"
		
		RLRTierSlotsTable["Chest"]="INVTYPE_CHEST"
		RLRTierSlotsTable["Chestguard"]="INVTYPE_CHEST"
		RLRTierSlotsTable["Regalia"]="INVTYPE_CHEST"
		
		RLRTierSlotsTable["Gauntlets"]="INVTYPE_HAND"
		RLRTierSlotsTable["Gloves"]="INVTYPE_HAND"
		
		RLRTierSlotsTable["Leggings"]="INVTYPE_LEGS"
		
		RLRTierSlotsTable["Belt"]="INVTYPE_WAIST"
	
		RLRTierSlotsTable["Boots"]="INVTYPE_FEET"
		
		RLRTierSlotsTable["Bracers"]="INVTYPE_WRIST"
		
		RLRTierSlotsTable["unknown"]=nil
	end
	
	local slotName=RLRTierSlotsTable[lootName]
	print ("RLR DEBUG 328 - slotName=",slotName)
	return slotName
end
	return slotName
end

function RLRFunctions.InspectItemSlot(itemSlot,doNotParseNames)
do
--	print("RLR DEBUG 203 - ItemSlot to inspect=",itemSlot)
	if RLRItemSlotsTable==nil then
		RLRItemSlotsTable={}
		RLRItemSlotsTable["INVTYPE_HEAD"]="HeadSlot"
		RLRItemSlotsTable["INVTYPE_NECK"]="NeckSlot"
		RLRItemSlotsTable["INVTYPE_SHOULDER"]="ShoulderSlot"
		RLRItemSlotsTable["INVTYPE_CHEST"]="ChestSlot"
		RLRItemSlotsTable["INVTYPE_ROBE"]="ChestSlot"

		RLRItemSlotsTable["INVTYPE_WAIST"]="WaistSlot"
		RLRItemSlotsTable["INVTYPE_LEGS"]="LegsSlot"
		RLRItemSlotsTable["INVTYPE_FEET"]="FeetSlot"
		RLRItemSlotsTable["INVTYPE_WRIST"]="WristSlot"
		RLRItemSlotsTable["INVTYPE_HAND"]="HandsSlot"
		RLRItemSlotsTable["INVTYPE_FINGER"]="Finger0Slot;Finger1Slot"--
		RLRItemSlotsTable["INVTYPE_TRINKET"]="Trinket0Slot;Trinket1Slot"--

		RLRItemSlotsTable["INVTYPE_CLOAK"]="BackSlot"
		RLRItemSlotsTable["INVTYPE_WEAPON"]="MainHandSlot"
		RLRItemSlotsTable["INVTYPE_SHIELD"]="SecondaryHandSlot"
		RLRItemSlotsTable["INVTYPE_2HWEAPON"]="MainHandSlot"
		RLRItemSlotsTable["INVTYPE_WEAPONMAINHAND"]="MainHandSlot"
		RLRItemSlotsTable["INVTYPE_WEAPONOFFHAND"]="SecondaryHandSlot"

		RLRItemSlotsTable["INVTYPE_HOLDABLE"]="SecondaryHandSlot"
		RLRItemSlotsTable["INVTYPE_RANGED"]="RangedSlot"
		RLRItemSlotsTable["INVTYPE_THROWN"]="RangedSlot"
		RLRItemSlotsTable["INVTYPE_RANGEDRIGHT"]="RangedSlot"
		RLRItemSlotsTable["INVTYPE_RELIC"]="RangedSlot"
		RLRItemSlotsTable["INVTYPE_BAG"]="Bag"
	end
	--print ("RLR DEBUG 248 - itemSlot=",itemSlot)
	local itemSlot=RLRItemSlotsTable[itemSlot] 
	--print ("RLR DEBUG 351 - itemSlot=",itemSlot)

	if itemSlot~="Finger0Slot;Finger1Slot" and itemSlot~= "Trinket0Slot;Trinket1Slot" and itemSlot~= nil then
		local slotId=GetInventorySlotInfo(itemSlot)
		local itemId = GetInventoryItemID("player", slotId)
		local itemLink=GetInventoryItemLink("player", slotId)
		local cItemName, cItemLink, itemRarity, cItemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId,itemLink) 
	--	print ("RLR DEBUG 255: itemName, itemLevel, itemLink	=",itemName,", ",itemLevel,", ",itemLink)
		return cItemName,cItemLevel,cItemLink
	end
	
	if itemSlot=="Finger0Slot;Finger1Slot" or itemSlot=="Trinket0Slot;Trinket1Slot" then
		print ("RLR DEBUG 259 - finger detected")
		local itemSlot1,itemSlot2=strsplit(";",itemSlot)
		local slotId1=GetInventorySlotInfo(itemSlot1)
		local slotId2=GetInventorySlotInfo(itemSlot2)
		local itemId1 = GetInventoryItemID("player", slotId1)
		local itemId2 = GetInventoryItemID("player", slotId2)
		local itemLink1=GetInventoryItemLink("player", slotId1)
		local itemLink2=GetInventoryItemLink("player", slotId2)
		local itemName1, itemLink21, itemRarity1, itemLevel1, itemMinLevel1, itemType1, itemSubType1, itemStackCount1,itemEquipLoc1, itemTexture1, itemSellPrice1 = GetItemInfo(itemId1,itemLink1) 
		local itemName2, itemLink22, itemRarity2, itemLevel2, itemMinLevel2, itemType2, itemSubType2, itemStackCount2,itemEquipLoc2, itemTexture2, itemSellPrice2 = GetItemInfo(itemId2,itemLink2)
		itemLevel1=tonumber(itemLevel1)
		itemLevel2=tonumber(itemLevel2)
		--print ("RLR DEBUG 272 - itemLevel1,itemLevel2=",itemLevel1,",",itemLevel2)
			if itemLevel1>=itemLevel2 then local cItemName,cItemLevel,cItemLink = itemName1,itemLevel1,itemLink1
			--	print ("RLR DEBUG 293 - cItemName,cItemLevel,cItemLink=",cItemName,",",cItemLevel,",",cItemLink)
				return cItemName,cItemLevel,cItemLink
				else local cItemName,cItemLevel,cItemLink = itemName2, itemLevel2,itemLink2
			return cItemName,cItemLevel,cItemLink
		end
		--print ("RLR DEBUG 297 - cItemName,cItemLevel,cItemLink=",cItemName,",",cItemLevel,",",cItemLink)
		return cItemName,cItemLevel,cItemLink
	end
		--print ("RLR DEBUG 299 - cItemName,cItemLevel,cItemLink=",cItemName,",",cItemLevel,",",cItemLink)
	return cItemName,cItemLevel,cItemLink
end
print ("RLR DEBUG 302, itemName,itemLevel,itemLink=",cItemName,cItemLevel,cItemLink)
if cItemName==nil then local 
cItemName,cItemLevel,cItemLink="-"
return cItemName,cItemLevel,cItemLink
end
return cItemName,cItemLevel,cItemLink
end

function RLRFunctions.VersionSay()
--todo register message prefixes for version check to rlr and rlrml
		if UnitInParty("Player") then
		--	print ("RLR DEBUG 169 - sending RLRSavedData.Version:",RLRVersion)
			SendAddonMessage("RLRVersion",RLRVersion,"RAID")
			RLRSession.VersionSaid=true
		end
end

function RLRFunctions.VersionListen(version)
--	print("RLR DEBUG 176 - version heard=",version)
	if version>RLRVersion and RLRSession.VersionHeard~=true then 
		print ("RLR DEBUG 176: A new version of RLR is available (",version,"), make sure to get it soon to ensure proper functioning.")
		RLRSession.VersionHeard=true
	end
end




function RLRFunctions.ShowFrame(arg1,message)
--print("RLR debug line 113 - message=",message)
do 
	local LootItemGUID,index,lootName,lootIcon,itemlink,itemLevel,itemEquipLoc,randomn=strsplit(";",message)
	print ("RLR DEBUG 457 (Showframe) -  LootItemGUID,index,lootName,lootIcon,itemlink,itemLevel,itemEquipLoc,randomn=",LootItemGUID,"-",index,"-",lootName,"-",lootIcon,"-",itemlink,"-",itemLevel,"-",itemEquipLoc,"-",randomn)
				   
	if _G[LootItemGUID.."Table"]==nil then _G[LootItemGUID.."Table"]={} end -- if this is the first time you see this GUID, make a table for it
	if 	_G[LootItemGUID.."Table"].lootIcon==nil then	-- if you don´t have the table content saved, save it
		_G[LootItemGUID.."Table"].GUID=LootItemGUID
		_G[LootItemGUID.."Table"].PlayersRolled={}
		_G[LootItemGUID.."Table"].lootIcon=lootIcon
		_G[LootItemGUID.."Table"].lootName=lootName
		_G[LootItemGUID.."Table"].index=index
		_G[LootItemGUID.."Table"].itemlink=itemlink
		_G[LootItemGUID.."Table"].itemLevel=itemLevel
		_G[LootItemGUID.."Table"].itemEquipLoc=itemEquipLoc
		_G[LootItemGUID.."Table"].randomn=randomn
	end

			local framenamejoined=strjoin(";","RLRLoot",LootItemGUID) --was index instead of GUID before
		
			if _G[framenamejoined]~=nil then -- if this is an item that you roll for and the roll frame already exists, show it
				_G[framenamejoined]:Show() -- 
				print ("RLR DEBUG 346: already opened rollframe for ",lootName," - don´t create the frame again, just show it!") -- temporary 
				if _G[LootItemGUID..";RollFrame"]~=nil then			-- if the roll recount frame should also be shown, show it too!
					_G[LootItemGUID..";RollFrame"]:Show()
				end
			end
			
			if _G[framenamejoined]==nil and arg1=="RLRItemLink" then	-- if this is an item that you roll for and the roll frame doesn´t exist, create it
				local FrameName = CreateFrame("frame",framenamejoined,UIParent,"RollFrame")
				_G[framenamejoined..";ItemName"]:SetText(itemlink)
				_G[framenamejoined..";IconOfLootItem"]:SetTexture(lootIcon)
				_G[framenamejoined..";Itemlevel"]:SetText(itemLevel)
			end
			
			if _G[framenamejoined]==nil and arg1=="RLRSKItem" then
				local FrameName = CreateFrame("frame",framenamejoined,UIParent,"SKFrame")
				_G[framenamejoined..";ItemName"]:SetText(itemlink)
				_G[framenamejoined..";IconOfLootItem"]:SetTexture(lootIcon)
				_G[framenamejoined..";Itemlevel"]:SetText(itemLevel)
			end
								
		--print ("RLR DEBUG 338:",itemlink," dropped, but it seems you´re not eligible to roll for it. If you think that it´s an error, please poke Gonerill-Frostmane(EU).")
	end
end



function RLRFunctions.Debug(ButtonName)
do
	local prefix,LootItemGUID,ButtonName=strsplit(";",ButtonName)
	print ("-----------------------<DEBUG:",_G[LootItemGUID.."Table"].itemlink,">-----------------------------------")
	print ("RLR DEBUG 178  FrameName=",prefix..";"..LootItemGUID)
	print ("RLR DEBUG 179  _G[LootItemGUID..'Table'].lootIcon=",_G[LootItemGUID.."Table"].lootIcon)
	print ("RLR DEBUG 180  _G[LootItemGUID..'Table'].itemlink=",_G[LootItemGUID.."Table"].itemlink)
	print ("RLR DEBUG 181  _G[LootItemGUID..'Table'].index=",_G[LootItemGUID.."Table"].index)
	print ("RLR DEBUG 182  _G[LootItemGUID..'Table'].itemEquipLoc=",_G[LootItemGUID.."Table"].itemEquipLoc)
	print ("-----------------------</DEBUG",_G[LootItemGUID.."Table"].itemlink,">------------------------------------")
	end
end

function RLRFunctions.HyperlinkClicked(ButtonName,button)
	do
	local framename,LootItemGUID=strsplit(";",ButtonName)
	if LootItemGUID=="RollFrame" then LootItemGUID,framename=strsplit(";",ButtonName) end
	local link=_G[LootItemGUID.."Table"].itemlink
	local text="text"
	SetItemRef(link, text, button);
   end
end

function RLRFunctions.RollAnnounce(message)
do
	--print ("RLR DEBUG 340 - RollAnnounce message contains ",strlen(message)," characters")
	local sender,roll,LootItemGUID,rollmin,rollmax,rolltype,ItemName,ItemLevel,itemLink,guildRankName=strsplit(";",message)
	local sendername,senderrealm=strsplit("-",sender)

	print (" |cFFFF0000",sendername,"|r rolls |cFF00FF00", roll,"|r on |cFF0000FF lootitem:",index," |r in the range ",rollmin,", ",rollmax," (",rolltype," upgrade roll)")

	if _G[LootItemGUID.."Table"]==nil then  -- LootItemGUID table doesn´t yet exist, create it
		_G[LootItemGUID.."Table"]={}
	end
	
	if _G[LootItemGUID..";RollFrame"]==nil then -- if the Roll recount frame doesn´t exist, create it
		local RollNumberParentName=strjoin("","RLRLoot;",LootItemGUID)
		local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[RollNumberParentName],"RollNumberFrame") 
		_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		_G[LootItemGUID..";RollFrame;Itemlevel2"]:SetText(_G[LootItemGUID.."Table"].itemLevel)
		RollNumberFrame:Show()
		RollNumberFrame:SetParent(nil)
	end
	
	if _G[LootItemGUID..";RollFrame"]:IsShown()==nil -- if Roll recount frame exists and is not shown, show it - possibly disable later?
		then  _G[LootItemGUID..";RollFrame"]:Show()
	end
		
	if _G[LootItemGUID.."Table"].Rolls==nil then -- if this is the first roll announced for this GUID
		_G[LootItemGUID.."Table"].Rolls={}
		_G[LootItemGUID.."Table"].HighestRoll=roll
		_G[LootItemGUID.."Table"].HighestSender=sendername
		_G[LootItemGUID.."Table"].HighestRollType=rolltype
		_G[LootItemGUID.."Table"].HighestCurrentItemName=ItemName
		_G[LootItemGUID.."Table"].HighestCurrentItemLevel=ItemLevel
		_G[LootItemGUID.."Table"].HighestCurrentItemLink=itemLink
		_G[LootItemGUID.."Table"].GuildRankName=guildRankName
		_G[LootItemGUID..";RollFrameRoll2"]:SetText(roll)
		_G[LootItemGUID..";RollFrameName"]:SetText(sendername)
		_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
--		print("RLR DEBUG 227: _G[LootItemGUID..'Table'].itemlink=",_G[LootItemGUID.."Table"].itemlink)
		_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		
	end
	
	if roll>_G[LootItemGUID.."Table"].HighestRoll then -- by now there should always be a HighestRoll set, so no need to worry about it being nil
		_G[LootItemGUID.."Table"].HighestRoll=roll
		_G[LootItemGUID.."Table"].HighestSender=sendername
		_G[LootItemGUID.."Table"].HighestRollType=rolltype
		_G[LootItemGUID.."Table"].HighestCurrentItemName=ItemName
		_G[LootItemGUID.."Table"].HighestCurrentItemLevel=ItemLevel
		_G[LootItemGUID.."Table"].HighestCurrentItemLink=itemLink
		_G[LootItemGUID.."Table"].GuildRankName=guildRankName
		_G[LootItemGUID..";RollFrameRoll2"]:SetText(roll)
		_G[LootItemGUID..";RollFrameName"]:SetText(sendername)
		-- need to update the highest roll part of the roll recount table 
	end
		
	tinsert (_G[LootItemGUID.."Table"].Rolls,roll)
	RLRFunctions.NameRollCount(sendername,rolltype)
	_G[LootItemGUID..";RollFrame;Disenchant"]:Hide()
end
end

 function RLRFunctions.GetMLName()
 local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
		
		if UnitInParty("Player") == nil then
	--	print ("Not in a party, sending RLRML comm to self")
		RLRName=GetUnitName("Player")
		
		elseif lootmethod ~= "master" then
		print ("RLR DEBUG 158 not using master looter")
		RLRName=GetUnitName("Player")
		
		elseif masterlooterRaidID ~= nil then --I´m in a raid, everything seems to work as intended
		RLRName = GetRaidRosterInfo(masterlooterRaidID)
		print ("RLR DEBUG: GETMLName name= ",RLRName)

		elseif masterlooterRaidID == nil and masterlooterPartyID == 0 and lootmethod == "master" then -- I´m not in a raid and ML is probably myself
		RLRName = GetUnitName("Player")
	--	print ("RLR DEBUG: GETMLName name= ",RLRName)
		
		elseif masterlooterRaidID == nil and masterlooterPartyID ~= 0 and lootmethod == "master" then -- I´m not in a raid, I AM in a party with the masterlooter and ML is probably not myself?
		local temp = strjoin ("","Party",masterlooterPartyID)
	--	print ("RLR DEBUG 170: GETMLName name= ",temp)
		RLRName,RLRrealm = GetUnitName(temp,true)
	--	print("RLR DEBUG 189, RLRName,RLRRealm=",RLRName,RLRrealm)
		RLRName=RLRConcatRealmName(RLRName,RLRrealm)
	-- still not showing realm name though
	-- print ("RLR DEBUG: GETMLName name=",RLRname)
		
	end
	--print ("RLRFunctions.GetMLName from RankedLootRoll.lua - RLRName=",RLRName)
	return RLRName
	end
	 
 function RLRFunctions.Channel() -- Takes care of creating/joining channel for communication between RLRML and RLR
	--print ("RLR DEBUG 239 RLRFunctions.Channel")
	do
	RLRName=RLRFunctions.GetMLName()
	if RLRName then
	local cname=RLRName	
	local cs = RLRFunctions.CheckSum(cname) -- cleaning the loot master name and adding checksum to create unique channel name
	local cname = RLRFunctions.Strip(cname)
	local cname = string.sub(cname, 1, 8)
	local GroupChannelName = ("RLR" .. cname .. cs)
--	print ("RLR and RLRML communication channel is called", GroupChannelName)
	SendAddonMessage("RLR",GroupChannelName,"RAID" );
	--SendChatMessage(GroupChannelName, "GUILD", nil) --debug, just checking if it works, remove later
--	print("RLR channel name=",GroupChannelName)
--  print("whisper target name=",RLRName)
	-- now join the channel if I´m not already in it
	
	--if tContains(GetChannelList(),GroupChannelName)==nil then
	--if GetChannelName(GroupChannelName) == nil then
	
	for index,value in ipairs(RLRChannels) do 
		if value~=GroupChannelName then
			LeaveChannelByName(value)
		print ("Leaving",value)
		end
	end
	wipe(RLRChannels)
	print ("joining channel ",GroupChannelName)
	
	JoinChannelByName(GroupChannelName)
	tinsert(RLRChannels, GroupChannelName)
	--else -- else tell me I´m already in
	--print ("already in the channel")
	--tinsert(RLRChannels, GroupChannelName)
	end
	end
	end

 
function RLRFunctions.ReceiveReply(Reply)
do
local roll,LootItemGUID,rollmin,rollmax,rolltype=strsplit(";",Reply)

	if _G[LootItemGUID.."Table"]==nil then
		_G[LootItemGUID.."Table"]={}
	end
	
	if _G[LootItemGUID..";RollFrame"]==nil then
		local RollNumberParentName=strjoin("","RLRLoot;",LootItemGUID)
		print("RLR DEBUG 297: Parent frame for roll recount frame is ",RollNumberParentName)
		local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[RollNumberParentName],"RollNumberFrame") -- replaced ButtonName by LootItemGUID as second arg on 31/08, still have 3rd arg to go
		RollNumberFrame:SetParent(nil)
		_G[RollNumberFrame.."IconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		_G[RollNumberFrame.."ItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		RollNumberFrame:Show()
		print ("RLR DEBUG 292 - itemlink for roll recount frame =",_G[LootItemGUID.."Table"].itemlink)
		--_G[RollNumberParentName]:GetParent():Hide()
	end
	
	if _G[LootItemGUID..";RollFrame"]~=nil then
	print ("RLR DEBUG 347 - Rollnumber frame already exists, not creating/showing it again")
	end
	
	local ReplyString=strjoin("","You roll |cFF00FF00", roll,"|r on |cFF0000FF lootitem:",LootItemGUID," |r in the range ",rollmin,", ",rollmax," (",rolltype," upgrade roll)")
	print("|cFF00FF00",ReplyString)
	_G[LootItemGUID..";RollFrameRoll1"]:SetText(roll)
	_G[LootItemGUID.."Table"].MyRoll=roll
	end
end

function RLRFunctions.OptionsPanel(...) -- RLR Options panel
   message('loading rlr options');
end


function RLRFunctions.Test(msg,par1,par2,par3)
		--print ("RLR DEBUG - no function currently assigned to test")
	 RLRFunctions.PlayerCounters()
end

function RLRFunctions.Roll(rolltype,LootItemGUID) -- is called by clicking a button on the lootframe
	local RLRName=RLRFunctions.GetMLName()
	--print ("RLR DEBUG 671 - itemEquipLoc=",_G[LootItemGUID.."Table"].itemEquipLoc)
	local cItemName,cItemLevel,cItemLink=RLRFunctions.InspectItemSlot(_G[LootItemGUID.."Table"].itemEquipLoc)

	local message=strjoin(";",rolltype,LootItemGUID,cItemName,cItemLevel,cItemLink)
	SendAddonMessage("RLRRoll",message,"WHISPER",RLRName)
	--print ("RLR DEBUG 520: RLRRoll message contains ",strlen(message)," characters")
  end
  
 function RLRFunctions.GetActiveRolls()
 local RLRName=RLRFunctions.GetMLName()
 	SendAddonMessage("RLRActiveRolls",nil,"WHISPER",RLRName)
 end
  
function RLRFunctions.Troll() -- for performing test rolls
	
--print ("RLR DEBUG 705 - UnitInRaid(Player)=",UnitInRaid("Player")," UnitInParty(Player)=",UnitInParty("Player"))
	if IsInGuild()==1 then
			local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
			local rollmin=(21-(2*pguildRankIndex))*10
			local rollmax=(21-(1*pguildRankIndex))*20
			local roll=math.random(rollmin,rollmax)
			local trollmessage=strjoin(" ",GetUnitName("Player"),"rolled",roll,"in range",rollmin,"-",rollmax,"as",pguildRankName)
			if UnitInRaid("Player")~=nil then SendChatMessage(trollmessage,"RAID")	end
			if (UnitInRaid("Player")==nil and UnitInParty("Player")==1) then SendChatMessage(trollmessage,"PARTY") end
			if (UnitInRaid("Player")==nil and UnitInParty("Player")==nil) then	print(trollmessage)	end
	end 
			
	if IsInGuild()==nil then			
			local pguildRankName="alt-not in guild"
			local rollmin=(21-(2*8))*10
			local rollmax=(21-(1*8))*20
			local roll=math.random(rollmin,rollmax)
			local trollmessage=strjoin(" ",GetUnitName("Player"),"rolled",roll,"in range",rollmin,"-",rollmax,"as",pguildRankName)
			print ("RLR DEBUG 719 - printing trollmessage",trollmessage)
			if UnitInRaid("Player")~=nil then SendChatMessage(trollmessage,"RAID")	end
			if (UnitInRaid("Player")==nil and UnitInParty("Player")==1) then SendChatMessage(trollmessage,"PARTY") end
			if (UnitInRaid("Player")==nil and UnitInParty("Player")==nil) then	print(trollmessage)	end
		end

end			
	
	
--WORK IN PROGRESS - SLASH COMMAND
SLASH_RLR1, SLASH_RLR2 = '/rlr', '/RLR'; 
function SlashCmdList.RLR(msgfull, editbox)--, editbox)
local msg,par1,par2,par3=strsplit(" ",msgfull)
local msg=strlower(msg)
 if msg == 'history' then
RLRFunctions.HistoryPanel()

 elseif msg == 'troll' then
RLRFunctions.Troll();

elseif msg == 'activerolls' then
RLRFunctions.GetActiveRolls();

 elseif msg == 'syncranks' then
RLRFunctions.RequestGuildRankSync(par1)

elseif msg == 'test' then
RLRFunctions.Test(msg,arg1,arg2,arg3)

elseif string.find(msg, "tableinsert") ~=  nil then -- if argument contains tableinsert, I want to insert the second argument

local RLRArgument = {strsplit(" ",msg,3)}
   print(msg)
   RLRFunctions.TableInsert(ar1,ar2,ar3); -- not working at the moment, ar1, ar2 and ar3 are nil
 else
 print("Raid Loot Roll has the following arguments");
 print("/rlr history to show history of awarded items");
 print("/rlr troll to perform a test roll");
 print("/rlr activerolls to synchronize active rolls with master looter if you had to reset while a roll was underway and couldn´t roll because of it")
 print("/rlr syncranks [playername]to synchronize guild rank roll values with the specified player or with current master looter if no playername is given");
 end
end


function RLRFunctions.SKBid(rolltype,LootItemGUID) -- is called by clicking a button on the lootframe
do
	local RLRName=RLRFunctions.GetMLName()

	local slotName=RLRFunctions.TierSlotMatch(_G[LootItemGUID.."Table"].lootName)
	local cItemName,cItemLevel,cItemLink=RLRFunctions.InspectItemSlot(slotName)
	print ("RLR DEBUG 740 - cItemName,cItemLevel,cItemLink =",cItemName,",", cItemLevel,",", cItemLink)

	local message=strjoin(";",rolltype,LootItemGUID,cItemName,cItemLevel,cItemLink)
	print ("RLR DEBUG 520: RLRRoll message contains ",strlen(message)," characters")
	SendAddonMessage("RLRBid",message,"WHISPER",RLRName)
  end
end






function RLRFunctions.SKButtonClick(ButtonName)
	do
	RLRFunctions.FreeSlots()	
	local framename,LootItemGUID,rolltype=strsplit(";",ButtonName)
	
		RLRFunctions.SKBid(rolltype,LootItemGUID)
		--print ("RLR DEBUG 667 - bid type=",rolltype)
		if _G[LootItemGUID..";RollFrame"]==nil then
			local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[ButtonName]:GetParent(),"RollNumberFrame") -- replaced ButtonName by LootItemGUID
			--print ("RLR DEBUG 390, _G[LootItemGUID..Table].itemlink=",_G[LootItemGUID.."Table"].itemlink)
			RollNumberFrame:Show()
			
			_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
			_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
			_G[LootItemGUID..";RollFrame;Itemlevel2"]:SetText(_G[LootItemGUID.."Table"].itemLevel)
			RollNumberFrame:Show()
			RollNumberFrame:SetParent(nil)
		end
		
		if _G[LootItemGUID..";RollFrame"]~=nil and _G[LootItemGUID..";RollFrame"]:IsShown()==nil then 
			_G[LootItemGUID..";RollFrame"]:Show()
		end
		
	_G[ButtonName]:GetParent():Hide()
	
	end
end

function RLRFunctions.FreeSlots()
	local freeslots={}
	for id=0,NUM_BAG_SLOTS do
		numfreeslots=GetContainerNumFreeSlots(id)
		tinsert (freeslots,numfreeslots)
	end
	local freeslots=RLRFunctions.TableSum(freeslots)
	
	if freeslots==0 then 
	print ("RLR warning - you are rolling for loot with no free bag spaces - make some space in your bag or if you win, the ML won´t be able to give you the item")
	end
end

function RLRFunctions.TableSum(table)
      local sum = 0
      for k,v in ipairs(table) do
        sum = sum + v
      end
      return sum
    end

function RLRFunctions.CheckEligibles(LootItemGUID)
print ("RLR DEBUG 830 - CheckEligibles")
local name, realm = UnitName("Player")
local eligible=nil
if (strfind(_G[LootItemGUID.."Table"].eligibles,","..name)~=nil or strfind(_G[LootItemGUID.."Table"].eligibles,name..",")~=nil) then local eligible=true
return eligible
end
return eligible
end
	
function RLRFunctions.RollButtonClick(ButtonName)
	do
	
	local framename,LootItemGUID,rolltype=strsplit(";",ButtonName)
	
	local eligible=RLRFunctions.CheckEligibles(LootItemGUID)
	
	if eligible==true then print ("RLR DEBUG 846 - seems like you´re eligible to roll for this") end
	if eligible==nil then print ("RLR DEBUG 847 - seems like you´re not eligible to roll for this") end
	
	
	RLRFunctions.FreeSlots()
	
		--print ("RLR DEBUG 422: index=",_G[LootItemGUID.."Table"].index)
		-- print ("rolltype=",rolltype)
		RLRFunctions.Roll(rolltype,LootItemGUID)
		if _G[LootItemGUID..";RollFrame"]==nil then
				local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[ButtonName]:GetParent(),"RollNumberFrame") -- replaced ButtonName by LootItemGUID
				--print ("RLR DEBUG 390, _G[LootItemGUID..Table].itemlink=",_G[LootItemGUID.."Table"].itemlink)
				RollNumberFrame:Show()
				
				_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
				_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
				_G[LootItemGUID..";RollFrame;Itemlevel2"]:SetText(_G[LootItemGUID.."Table"].itemLevel)
				RollNumberFrame:Show()
				RollNumberFrame:SetParent(nil)
		end
		
		if _G[LootItemGUID..";RollFrame"]~=nil and _G[LootItemGUID..";RollFrame"]:IsShown()==nil then 
						_G[LootItemGUID..";RollFrame"]:Show()
				end
		
	_G[ButtonName]:GetParent():Hide()
	end
end



StaticPopupDialogs["CONFIRM_NUKE"] = {
    text = "Do you want to delete your RLR history data?";
    button1 = ACCEPT,
    button2 = CANCEL,
    OnShow = function(self)
        self.timeleft = 30;
    end,
    OnAccept = function(self)
        print("accepted");
    end,
    OnCancel = function()
        print("declined");
    end,
    OnUpdate = function(self, elapsed)
        if ( UnitAffectingCombat("player") or (not PlayerCanTeleport()) ) then
            self.button1:Disable();
        else
            self.button1:Enable();
        end
    end,
    timeout = 0,
    interruptCinematic = 1,
    notClosableByLogout = 1,
    hideOnEscape = 1
};

function RLRFunctions.GetEquippedItemLevel(InvType)
local SlotName=RLRItemSlotsTable[InvType]
print ("RLR DEBUG 487 SlotName for ",InvType,"=",SlotName)
local SlotName1,SlotName2=strsplit(";",SlotName)
return SlotName1,SlotName2
end


-- HIC SUNT LEONES
-- Most of the scrolling frame for HistoryPanel comes from us.battle.net/wow/en/forum/topic/14058226633 - hopefully in time I´ll understand how it works 

function RLRFunctions.HistoryPanel()

table.sort(RLRHistoryIndex, function(a,b) return b<a end)

if RLRHistoryWrapper==nil then do

	-- local data = nil
	-- local data2 = nil
	-- local data3 = nil
	-- local data4 = nil
	-- local data5 = nil
	-- local data6 = nil
	local data = {}
	local data2 = {}
	local data3 = {}
	local data4 = {}
	local data5 = {}
	local data6 = {}
	local scrollFrame -- we'll define this later
	local numButtons = 10 -- number of lines to scrollFrame
	local buttonHeight = 16 -- height of each line

	-- fill data will test data to scroll through

	for k,v in pairs (RLRHistoryIndex) do
		-- structure of history table is: 1-name, 2-old item, 3-new itemname,4-new itemlink,5-new itemlevel, 6-old itemlevel, 7-rolltype, 8-date+time
		
	-- ["20140929144529410"] = {
		-- "Gonerill", -- [1]
		-- "Major", -- [2]
		-- "Veiled Amulet of Life", -- [3]
		-- "|cffa335ee|Hitem:39392:0:0:0:0:0:0:276451072:90:0:0|h[Veiled Amulet of Life]|h|r", -- [4]
		-- "200", -- [5]
		-- "|cffa335ee|Hitem:105465:0:0:0:0:0:0:0:90:0:0|h[Untainted Guardian's Chain]|h|r", -- [6]
		-- "572", -- [7]
		-- "09/29/14 14:46:23", -- [8]
		-- "2-Officer", -- [9]
	-- },

		--local line1,line2,line3,line4,line5,line6,line7,line8=unpack(v)
		
		local line1,line2,line3,line4,line5,line6,line7,line8,line9=unpack(RLRHistory[v])
		
		if RLRHistoryFilter==nil or strfind(strlower(strjoin("",line1,line2,line3,line4,line5,line6,line7,line8,line9)),strlower(RLRHistoryFilter))~=nil then
			tinsert (data,line8)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line1)	-- 	second column = name
			tinsert (data3,line4)	-- 	third column = itemlink
			tinsert (data4,strjoin("",line5,"(",line7,")"))	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line6)	--	fifth colum = old item name
			tinsert (data6,line2)	--	sixth column = rolltype
		end
	end
	print ("RLR XML DEBUG 916 - history table contains", #data, " lines")


	-- the heart of the scrollframe that updates the buttons
	function update(search)
	if search~=nil then 
			wipe(data)
			wipe(data2)
			wipe(data3)
			wipe(data4)
			wipe(data5)
			wipe(data6)
			
		for k,v in pairs (RLRHistoryIndex) do
			local line1,line2,line3,line4,line5,line6,line7,line8,line9=unpack(RLRHistory[v])
		
			if RLRHistoryFilter==nil or strfind(strlower(strjoin("",line1,line2,line3,line4,line5,line6,line7,line8,line9)),strlower(RLRHistoryFilter))~=nil then
			tinsert (data,line8)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line1)	-- 	second column = name
			tinsert (data3,line4)	-- 	third column = itemlink
			tinsert (data4,strjoin("",line5,"(",line7,")"))	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line6)	--	fifth colum = old item name
			tinsert (data6,line2)	--	sixth column = rolltype
			end
		end
	end
		FauxScrollFrame_Update(scrollFrame,#data,numButtons,buttonHeight)
	for index = 1,numButtons do
	local offset = index + FauxScrollFrame_GetOffset(scrollFrame)
	local button = scrollFrame.buttons[index]
	local button2 = scrollFrame.buttons2[index]
	local button3 = scrollFrame.buttons3[index]
	local button4 = scrollFrame.buttons4[index]
	local button5 = scrollFrame.buttons5[index]
	local button6 = scrollFrame.buttons6[index]
	
	button.index = offset
	button2.index = offset
	button3.index = offset
	button4.index = offset
	button5.index = offset
	button6.index = offset
	
	if offset<=#data then
	button:SetText(data[offset])
	button:Show()
	
	button2:SetText(data2[offset])
	button2:Show()

	button3:SetText(data3[offset])
	button3:Show()

	button4:SetText(data4[offset])
	button4:Show()

	button5:SetText(data5[offset])
	button5:Show()
	
	button6:SetText(data6[offset])
	button6:Show()

	
	else
	button:Hide()
	button2:Hide()
	button3:Hide()
	button4:Hide()
	button5:Hide()
	button6:Hide()
	end
	end
	end
	
	
	local RLRHistoryWrapper=CreateFrame("Frame","RLRHistoryWrapper",UIParent,"RLRHistoryOuterFrameTemplate")
	RLRHistoryWrapper:SetPoint("TOPLEFT",200,-200)
	tinsert(UISpecialFrames,"RLRHistoryWrapper");
	
	
	-- create parent frame
	local frame = CreateFrame("Frame","RLRHistoryFrame",RLRHistoryWrapper)
	frame:SetSize(890,numButtons*buttonHeight+16)
	frame:SetPoint("CENTER",0,-20)
	frame:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	
	
	-- create the scrollFrame
	scrollFrame = CreateFrame("ScrollFrame","RLRHistoryFrameScrollFrame",frame,"FauxScrollFrameTemplate")
	scrollFrame:SetPoint("TOPLEFT",0,-8)
	scrollFrame:SetPoint("BOTTOMRIGHT",-30,8)
	scrollFrame:SetScript("OnVerticalScroll",function(self,offset)
	FauxScrollFrame_OnVerticalScroll(self, offset, buttonHeight, update)
	end)

	-- add a button to hide the frame
	local historyCloseButton = CreateFrame("Button","RLRHistoryFrameClose",RLRHistoryWrapper,"UIPanelCloseButton")
	historyCloseButton:SetSize(32,32)
	historyCloseButton:SetPoint("TOPRIGHT",-5,-5)


	-- create each line(button) within the scrollFrame
	scrollFrame.buttons = {}
	scrollFrame.buttons2 = {}
	scrollFrame.buttons3 = {}
	scrollFrame.buttons4 = {}
	scrollFrame.buttons5 = {}
	scrollFrame.buttons6 = {}
	for i=1,numButtons do
		scrollFrame.buttons[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons2[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons3[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons4[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons5[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons6[i] = CreateFrame("Button",nil,frame)
		
		local button = scrollFrame.buttons[i]
		button:SetSize(150,buttonHeight)
		button:SetNormalFontObject("GameFontHighlightLeft")
		button:SetPoint("TOPLEFT",8,-(i-1)*buttonHeight-8)
		button:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data[self.index])
			GameTooltip:Show()
		end)
		button:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data[self.index])
		update()
		end)

		
		-- here I´m copying lua for button 1 to button 2
		local button2 = scrollFrame.buttons2[i]
		button2:SetSize(90,buttonHeight)
		button2:SetNormalFontObject("GameFontHighlightLeft")
		button2:SetPoint("TOPLEFT",160,-(i-1)*buttonHeight-8)
		button2:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data2[self.index])
			GameTooltip:Show()
		end)
		button2:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button2:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data2[self.index])
		update()
		end)

local button3 = scrollFrame.buttons3[i]
		button3:SetSize(250,buttonHeight)
		button3:SetNormalFontObject("GameFontHighlightLeft")
		button3:SetPoint("TOPLEFT",250,-(i-1)*buttonHeight-8) -- ends at 170+200
		button3:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data3[self.index])
			GameTooltip:Show()
		end)
		button3:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button3:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
		SetItemRef(data3[self.index], "-","LeftButton");
		print(data3[self.index])
		update()
		end)

local button4 = scrollFrame.buttons4[i]
		button4:SetSize(60,buttonHeight)
		button4:SetNormalFontObject("GameFontHighlightLeft")
		button4:SetPoint("TOPLEFT",500,-(i-1)*buttonHeight-8) -- ends at 370+60
		button4:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data4[self.index])
			GameTooltip:Show()
		end)
		button4:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button4:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data4[self.index])
			--tremove(data,self.index)
		update()
		end)

local button5 = scrollFrame.buttons5[i]
		button5:SetSize(250,buttonHeight)
		button5:SetNormalFontObject("GameFontHighlightLeft")
		button5:SetPoint("TOPLEFT",565,-(i-1)*buttonHeight-8) --ends at 430+200
		button5:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data5[self.index])
			GameTooltip:Show()
		end)
		button5:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button5:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			SetItemRef(data5[self.index], "-","LeftButton");
			print(data5[self.index])
			--tremove(data,self.index)
		update()
		end)

local button6 = scrollFrame.buttons6[i]
		button6:SetSize(50,buttonHeight)
		button6:SetNormalFontObject("GameFontHighlightLeft")
		button6:SetPoint("TOPLEFT",810,-(i-1)*buttonHeight-8) --ends at 680
		button6:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data6[self.index])
			GameTooltip:Show()
		end)
		button6:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button6:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data6[self.index])
			--tremove(data,self.index)
		update()
		end)

		end
	
	update() -- always remember to kick off first update, in an OnShow usually
	
	end

else 
		if RLRHistoryWrapper:IsShown() then 
		print("Hiding RLR history")
			RLRHistoryWrapper:Hide()
	else
	print("Showing RLR history")
			RLRHistoryWrapper:Show()
			update()
	end
end
end

function RLRFunctions.PlayerCounters()

table.sort(RLRPlayerCounters, function(a,b) return b>a end)

if PlayerCountersWrapper==nil then do

	local data = {}
	local data2 = {}
	local data3 = {}
	local data4 = {}
	local data5 = {}
	local data6 = {}
	local scrollFrame -- we'll define this later
	local numButtons = 10 -- number of lines to scrollFrame
	local buttonHeight = 16 -- height of each line

	for k,v in pairs (RLRPlayerCounters)  do
	
	-- structure of history table is: 1-name, 2-old item, 3-new itemname,4-new itemlink,5-new itemlevel, 6-old itemlevel, 7-rolltype, 8-date+time
		
	-- ["20140929144529410"] = {
		-- "Gonerill", -- [1]
		-- "Major", -- [2]
		-- "Veiled Amulet of Life", -- [3]
		-- "|cffa335ee|Hitem:39392:0:0:0:0:0:0:276451072:90:0:0|h[Veiled Amulet of Life]|h|r", -- [4]
		-- "200", -- [5]
		-- "|cffa335ee|Hitem:105465:0:0:0:0:0:0:0:90:0:0|h[Untainted Guardian's Chain]|h|r", -- [6]
		-- "572", -- [7]
		-- "09/29/14 14:46:23", -- [8]
		-- "2-Officer", -- [9]
	-- },
	if type(k)=="table" then
		local line1,line2,line3,line4,line5,line6=unpack(v)
		
		--if RLRHistoryFilter==nil or strfind(strlower(strjoin("",line1,line2,line3,line4,line5,line6,line7,line8,line9)),strlower(RLRHistoryFilter))~=nil then
			tinsert (data,k)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line1)	-- 	second column = name
			tinsert (data3,line2)	-- 	third column = itemlink
			tinsert (data4,line3)	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line4)	--	fifth colum = old item name
			tinsert (data6,line5)	--	sixth column = rolltype
		--end
	end
	end
	print ("RLR XML DEBUG 1213 - RLRPlayerCounters table contains", #data, " lines")


	-- the heart of the scrollframe that updates the buttons
	function update(search)
	if search~=nil then 
			wipe(data)
			wipe(data2)
			wipe(data3)
			wipe(data4)
			wipe(data5)
			wipe(data6)
			
		for k,v in pairs (RLRPlayerCounters) do
			if type(k)=="table" then
			local line1,line2,line3,line4,line5,line6,line7,line8,line9=unpack(v)
			tinsert (data,line8)	-- 	first column = date in mm/dd/yy format
			tinsert (data2,line1)	-- 	second column = name
			tinsert (data3,line4)	-- 	third column = itemlink
			tinsert (data4,strjoin("",line5,"(",line7,")"))	--	fourth column = new ilvl(old ilvl)
			tinsert (data5,line6)	--	fifth colum = old item name
			tinsert (data6,line2)	--	sixth column = rolltype
			end
			
		end
	end
		FauxScrollFrame_Update(scrollFrame,#data,numButtons,buttonHeight)
	for index = 1,numButtons do
	local offset = index + FauxScrollFrame_GetOffset(scrollFrame)
	local button = scrollFrame.buttons[index]
	local button2 = scrollFrame.buttons2[index]
	local button3 = scrollFrame.buttons3[index]
	local button4 = scrollFrame.buttons4[index]
	local button5 = scrollFrame.buttons5[index]
	local button6 = scrollFrame.buttons6[index]
	
	button.index = offset
	button2.index = offset
	button3.index = offset
	button4.index = offset
	button5.index = offset
	button6.index = offset
	
	if offset<=#data then
	button:SetText(data[offset])
	button:Show()
	
	button2:SetText(data2[offset])
	button2:Show()

	button3:SetText(data3[offset])
	button3:Show()

	button4:SetText(data4[offset])
	button4:Show()

	button5:SetText(data5[offset])
	button5:Show()
	
	button6:SetText(data6[offset])
	button6:Show()

	
	else
	button:Hide()
	button2:Hide()
	button3:Hide()
	button4:Hide()
	button5:Hide()
	button6:Hide()
	end
	end
	end
	
	
	local RLRHistoryWrapper=CreateFrame("Frame","RLRHistoryWrapper",UIParent,"RLRHistoryOuterFrameTemplate")
	RLRHistoryWrapper:SetPoint("TOPLEFT",200,-200)
	tinsert(UISpecialFrames,"RLRHistoryWrapper");
	
	
	-- create parent frame
	local frame = CreateFrame("Frame","RLRHistoryFrame",RLRHistoryWrapper)
	frame:SetSize(890,numButtons*buttonHeight+16)
	frame:SetPoint("CENTER",0,-20)
	frame:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	
	
	-- create the scrollFrame
	scrollFrame = CreateFrame("ScrollFrame","RLRHistoryFrameScrollFrame",frame,"FauxScrollFrameTemplate")
	scrollFrame:SetPoint("TOPLEFT",0,-8)
	scrollFrame:SetPoint("BOTTOMRIGHT",-30,8)
	scrollFrame:SetScript("OnVerticalScroll",function(self,offset)
	FauxScrollFrame_OnVerticalScroll(self, offset, buttonHeight, update)
	end)

	-- add a button to hide the frame
	local historyCloseButton = CreateFrame("Button","RLRHistoryFrameClose",RLRHistoryWrapper,"UIPanelCloseButton")
	historyCloseButton:SetSize(32,32)
	historyCloseButton:SetPoint("TOPRIGHT",-5,-5)


	-- create each line(button) within the scrollFrame
	scrollFrame.buttons = {}
	scrollFrame.buttons2 = {}
	scrollFrame.buttons3 = {}
	scrollFrame.buttons4 = {}
	scrollFrame.buttons5 = {}
	scrollFrame.buttons6 = {}
	for i=1,numButtons do
		scrollFrame.buttons[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons2[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons3[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons4[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons5[i] = CreateFrame("Button",nil,frame)
		scrollFrame.buttons6[i] = CreateFrame("Button",nil,frame)
		
		local button = scrollFrame.buttons[i]
		button:SetSize(150,buttonHeight)
		button:SetNormalFontObject("GameFontHighlightLeft")
		button:SetPoint("TOPLEFT",8,-(i-1)*buttonHeight-8)
		button:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data[self.index])
			GameTooltip:Show()
		end)
		button:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data[self.index])
		update()
		end)

		
		-- here I´m copying lua for button 1 to button 2
		local button2 = scrollFrame.buttons2[i]
		button2:SetSize(90,buttonHeight)
		button2:SetNormalFontObject("GameFontHighlightLeft")
		button2:SetPoint("TOPLEFT",160,-(i-1)*buttonHeight-8)
		button2:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data2[self.index])
			GameTooltip:Show()
		end)
		button2:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button2:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data2[self.index])
		update()
		end)

local button3 = scrollFrame.buttons3[i]
		button3:SetSize(250,buttonHeight)
		button3:SetNormalFontObject("GameFontHighlightLeft")
		button3:SetPoint("TOPLEFT",250,-(i-1)*buttonHeight-8) -- ends at 170+200
		button3:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data3[self.index])
			GameTooltip:Show()
		end)
		button3:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button3:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
		SetItemRef(data3[self.index], "-","LeftButton");
		print(data3[self.index])
		update()
		end)

local button4 = scrollFrame.buttons4[i]
		button4:SetSize(60,buttonHeight)
		button4:SetNormalFontObject("GameFontHighlightLeft")
		button4:SetPoint("TOPLEFT",500,-(i-1)*buttonHeight-8) -- ends at 370+60
		button4:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data4[self.index])
			GameTooltip:Show()
		end)
		button4:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button4:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data4[self.index])
			--tremove(data,self.index)
		update()
		end)

local button5 = scrollFrame.buttons5[i]
		button5:SetSize(250,buttonHeight)
		button5:SetNormalFontObject("GameFontHighlightLeft")
		button5:SetPoint("TOPLEFT",565,-(i-1)*buttonHeight-8) --ends at 430+200
		button5:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data5[self.index])
			GameTooltip:Show()
		end)
		button5:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button5:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			SetItemRef(data5[self.index], "-","LeftButton");
			print(data5[self.index])
			--tremove(data,self.index)
		update()
		end)

local button6 = scrollFrame.buttons6[i]
		button6:SetSize(50,buttonHeight)
		button6:SetNormalFontObject("GameFontHighlightLeft")
		button6:SetPoint("TOPLEFT",810,-(i-1)*buttonHeight-8) --ends at 680
		button6:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self,"ANCHOR_LEFT")
			GameTooltip:AddLine(data6[self.index])
			GameTooltip:Show()
		end)
		button6:SetScript("OnLeave",function(self)
			GameTooltip:Hide()
		end)
		button6:SetScript("OnClick",function(self) -- here I can add stuff to do upon clicking an entry
			print("--"..data6[self.index])
			--tremove(data,self.index)
		update()
		end)

		end
	
	update() -- always remember to kick off first update, in an OnShow usually
	
	end

else 
		if RLRHistoryWrapper:IsShown() then 
		print("Hiding RLR history")
			RLRHistoryWrapper:Hide()
	else
	print("Showing RLR history")
			RLRHistoryWrapper:Show()
			update()
	end
end
end
